/* $Id$
 *
 * wdefs.c
 */

/**************************************************************************
 *     Copyright (C) 1990 by Mark B. Phillips and Robert R. Miner	  *
 * 									  *
 * Permission to use, copy, modify, and distribute this software, its	  *
 * documentation, and any images it generates for any purpose and without *
 * fee is hereby granted, provided that					  *
 * 									  *
 * (1) the above copyright notice appear in all copies and that both that *
 *     copyright notice and this permission notice appear in supporting	  *
 *     documentation, and that the names of Mark B.  Phillips, Robert R.  *
 *     Miner, or the University of Maryland not be used in advertising or *
 *     publicity pertaining to distribution of the software without	  *
 *     specific, written prior permission.				  *
 *									  *
 * (2) Explicit written credit be given to the authors Mark B.  Phillips  *
 *     and Robert R. Miner in any publication which uses part or all of	  *
 *     any image produced by this software.				  *
 *									  *
 * This software is provided "as is" without express or implied warranty. *
 **************************************************************************/

#define	HELP_BUTTON_X		(BSEP/2)
#define	HELP_BUTTON_Y		(BSEP/2)
#define	PRINT_BUTTON_X		(HELP_BUTTON_X+BSEP+BWIDTH)
#define	PRINT_BUTTON_Y		(HELP_BUTTON_Y)
#define	EXIT_BUTTON_X		(PRINT_BUTTON_X+BSEP+BWIDTH)
#define	EXIT_BUTTON_Y		(HELP_BUTTON_Y)

#define	ZOOM_BUTTON_X		(HELP_BUTTON_X)
#define	ZOOM_BUTTON_Y		(HELP_BUTTON_Y+BSEP+BHEIGHT)
#define	RECENTER_BUTTON_X	(ZOOM_BUTTON_X+BSEP+BWIDTH)
#define	RECENTER_BUTTON_Y	(ZOOM_BUTTON_Y)
#define	RESET_BUTTON_X		(RECENTER_BUTTON_X+BSEP+BWIDTH)
#define	RESET_BUTTON_Y		(ZOOM_BUTTON_Y)

#define	ZOOM_FACTOR_LABEL_MSG_X	31
#define	ZOOM_FACTOR_LABEL_MSG_Y	(RESET_BUTTON_Y+BHEIGHT+7)
#define	ZOOM_FACTOR_SLIDER_X	12
#define	ZOOM_FACTOR_SLIDER_Y	(ZOOM_FACTOR_LABEL_MSG_Y+17)
#define	ZOOM_FACTOR_VALUE_MSG_X	54
#define	ZOOM_FACTOR_VALUE_MSG_Y	(ZOOM_FACTOR_SLIDER_Y+19)

#define VIEWPORT_X_LABEL_X	5
#define VIEWPORT_X_LABEL_Y	(ZOOM_FACTOR_VALUE_MSG_Y+24)
#define VIEWPORT_X_VALUE_X	10
#define VIEWPORT_X_VALUE_Y	(VIEWPORT_X_LABEL_Y+19)

#define VIEWPORT_Y_LABEL_X	5
#define VIEWPORT_Y_LABEL_Y	(VIEWPORT_X_VALUE_Y+19)
#define VIEWPORT_Y_VALUE_X	10
#define VIEWPORT_Y_VALUE_Y	(VIEWPORT_Y_LABEL_Y+19)

#define CENTER_LABEL_X		5
#define CENTER_LABEL_Y		(VIEWPORT_Y_VALUE_Y+24)
#define CENTER_VALUE_X		10
#define CENTER_VALUE_Y		(CENTER_LABEL_Y+19)

#define MODEL_CYCLE_LABEL_X	5
#define MODEL_CYCLE_LABEL_Y	(CENTER_VALUE_Y+24)

#define MODEL_CYCLE_X		35
#define MODEL_CYCLE_Y		(MODEL_CYCLE_LABEL_Y+19)

#define DRAWING_MODE_LABEL_X	5
#define DRAWING_MODE_LABEL_Y	(MODEL_CYCLE_Y+24)

#define DRAWING_MODE_CYCLE_X	35
#define DRAWING_MODE_CYCLE_Y	(DRAWING_MODE_LABEL_Y+19)

#define MESSAGE_MSG_X		10
#define MESSAGE_MSG_Y		10

#define WINHEIGHT(win)		((int)window_get(win,WIN_HEIGHT))
#define WINWIDTH(win)		((int)window_get(win,WIN_WIDTH))
#define WINTOPMARGIN(win)	((int)window_get(win,WIN_TOP_MARGIN))

#define BWIDTH		48	/* width of panel buttons */
#define	BHEIGHT		48	/* height of panel buttons */
#define	BSEP		2	/* separation between panel buttons */

#define	WSEP		5	/* separation between windows in frame */

#define	MESSAGE_PANEL_HEIGHT	66

#define	CONTROL_PANEL_WIDTH		(3*(BWIDTH+BSEP))
#define MIN_CONTROL_PANEL_HEIGHT	335

#define MINI_CANVAS_LENGTH	CONTROL_PANEL_WIDTH
#define MINI_CANVAS_WIDTH	MINI_CANVAS_LENGTH
#define MINI_CANVAS_HEIGHT	MINI_CANVAS_LENGTH

#define MIN_CANVAS_LENGTH	( MIN_CONTROL_PANEL_HEIGHT \
				+ WSEP \
				+ MINI_CANVAS_HEIGHT \
				+ WSEP )

#define MIN_CANVAS_WIDTH	MIN_CANVAS_LENGTH
#define MIN_CANVAS_HEIGHT	MIN_CANVAS_LENGTH

#define MIN_FRAME_HEIGHT	( WINTOPMARGIN(wFrame) \
				+ WSEP \
				+ MESSAGE_PANEL_HEIGHT \
				+ WSEP \
				+ MIN_CONTROL_PANEL_HEIGHT \
				+ WSEP \
				+ MINI_CANVAS_HEIGHT \
				+ WSEP )


#define MIN_FRAME_WIDTH		( WSEP \
				+ MIN_CANVAS_WIDTH \
				+ WSEP \
				+ CONTROL_PANEL_WIDTH \
				+ WSEP )


#define	DEFAULT_FRAME_HEIGHT	700
#define	DEFAULT_FRAME_WIDTH	700


